{$mode objfpc}
unit u_light;

interface
uses u_graph, u_list;

type
   TColorState = array[Boolean] of Color_Type;

   TLight =
   record
      X, Y : Integer;
      Color : TColorState;
      Is_Active : Boolean;
   end;

const
   maxLightColors = 4;

type
   lcArray = array[0 .. maxLightColors - 1] of TColorState;
const
   Light_Colors : lcArray =
   (
      (DkBlue_Color, LtBlue_Color),
      (DkRed_Color, LtRed_Color),
      (DkYellow_Color, LtYellow_Color),
      (DkMagenta_Color, LtMagenta_Color)
   );

   // Constructor
   function Light_Create (Px, Py : Integer; AColor : TColorState) : TLight;

   // Method
   procedure Show (L : TLight);


   // List iterators
   procedure Show_Node (var L : TLight);
   procedure Light_Lamp (var L : TLight);

type
   Light_List = specialize List<TLight>;
var
   LightList : Light_List;


implementation
uses u_random;

   function Light_Create (Px, Py : Integer; AColor : TColorState) : TLight;
   begin
      with Result do
      begin
         X := Px;
         Y := Py;
         Color := AColor;
         Is_Active := False;
      end;
   end; { Light_Create }

   procedure Light_Lamp (var L : TLight);
   begin

      if Get_Prob (5) then
      begin
         L.Is_Active := not L.Is_Active;
         Show (L);
      end;

   end; { Light_Lamp }

   procedure Show (L : TLight);
   begin
      Set_SolidBrush (L.Color[L.Is_Active]);
      Set_Color (L.Color[L.Is_Active]);
      Fill_Circle (L.X, L.Y, 5);
      Set_Color (White_Color);
      Draw_Circle (L.X, L.Y, 5);
   end; { Show }

   procedure Show_Node (var L : TLight);
   begin
      Show (L);
   end; { Show_Node }

end.
