{$mode objfpc}

unit u_vector;

interface

type
   generic Vector<T> =
   class
   var private
      Arr : array of T;
      Len : Integer;

   public
      constructor Create;
      destructor Destroy; override;

      function Count : Integer;
      function Element (Index : Integer) : T;
      procedure Append (Value : T);

   private
      procedure Clear;
   end;

implementation

constructor Vector.Create;
begin
   inherited;
   Len := 0;
end;

destructor Vector.Destroy;
begin
   Clear;
   inherited;
end;

procedure Vector.Clear;
begin
   Arr := nil;
   Len := 0;
end;

function Vector.Count : Integer;
begin
   Result := Len;
end;

function Vector.Element (Index : Integer) : T;
begin
   Result := Arr[Index];
end;

procedure Vector.Append (Value : T);
begin
   SetLength (Arr, Len + 1);
   Arr[Len] := Value;
   Inc (Len);
end;

end.
